## sentencepiece 0.1.1

=== DESCRIPTION ===
Package: sentencepiece
Type: Package
Title: Text Tokenization using Byte Pair Encoding and Unigram Modelling
Version: 0.1.1
Authors@R: c(
    person('Jan', 'Wijffels', role = c('aut', 'cre', 'cph'), email = 'jwijffels@bnosac.be', comment = "R wrapper"), 
    person('BNOSAC', role = 'cph', comment = "R wrapper"), 
    person('Google Inc.', role = c('ctb', 'cph'), comment = "Files at src/sentencepiece/src (Apache License, Version 2.0"),
    person('The Abseil Authors', role = c('ctb', 'cph'), comment = "Files at src/third_party/absl (Apache License, Version 2.0"),
    person('Google Inc.', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite (BSD-3 License)"),
    person('Kenton Varda (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: coded_stream.cc, extension_set.cc, generated_message_util.cc, generated_message_util.cc, message_lite.cc, repeated_field.cc, wire_format_lite.cc, zero_copy_stream.cc, zero_copy_stream_impl_lite.cc, google/protobuf/extension_set.h, google/protobuf/generated_message_util.h, google/protobuf/wire_format_lite.h, google/protobuf/wire_format_lite_inl.h, google/protobuf/message_lite.h, google/protobuf/repeated_field.h, google/protobuf/io/coded_stream.h, google/protobuf/io/zero_copy_stream_impl_lite.h, google/protobuf/io/zero_copy_stream.h, google/protobuf/stubs/common.h, google/protobuf/stubs/hash.h, google/protobuf/stubs/once.h, google/protobuf/stubs/once.h.org (BSD-3 License)"),
    person('Sanjay Ghemawat (Google Inc.)', role = c('ctb', 'cph'), comment = "Design of files at src/third_party/protobuf-lite: coded_stream.cc, extension_set.cc, generated_message_util.cc, generated_message_util.cc, message_lite.cc, repeated_field.cc, wire_format_lite.cc, zero_copy_stream.cc, zero_copy_stream_impl_lite.cc, google/protobuf/extension_set.h, google/protobuf/generated_message_util.h, google/protobuf/wire_format_lite.h, google/protobuf/wire_format_lite_inl.h, google/protobuf/message_lite.h, google/protobuf/repeated_field.h, google/protobuf/io/coded_stream.h, google/protobuf/io/zero_copy_stream_impl_lite.h, google/protobuf/io/zero_copy_stream.h (BSD-3 License)"),
    person('Jeff Dean (Google Inc.)', role = c('ctb', 'cph'), comment = "Design of files at src/third_party/protobuf-lite: coded_stream.cc, extension_set.cc, generated_message_util.cc, generated_message_util.cc, message_lite.cc, repeated_field.cc, wire_format_lite.cc, zero_copy_stream.cc, zero_copy_stream_impl_lite.cc, google/protobuf/extension_set.h, google/protobuf/generated_message_util.h, google/protobuf/wire_format_lite.h, google/protobuf/wire_format_lite_inl.h, google/protobuf/message_lite.h, google/protobuf/repeated_field.h, google/protobuf/io/coded_stream.h, google/protobuf/io/zero_copy_stream_impl_lite.h, google/protobuf/io/zero_copy_stream.h (BSD-3 License)"),
    person('Laszlo Csomor (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: io_win32.cc, google/protobuf/stubs/io_win32.h  (BSD-3 License)"),
    person('Wink Saville (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: message_lite.cc, google/protobuf/wire_format_lite.h, google/protobuf/wire_format_lite_inl.h, google/protobuf/message_lite.h (BSD-3 License)"),
    person('Jim Meehan (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: structurally_valid.cc (BSD-3 License)"),
    person('Chris Atenasio (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: google/protobuf/wire_format_lite.h (BSD-3 License)"),
    person('Jason Hsueh (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: google/protobuf/io/coded_stream_inl.h (BSD-3 License)"),
    person('Anton Carver (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: google/protobuf/stubs/map_util.h (BSD-3 License)"),
    person('Maxim Lifantsev (Google Inc.)', role = c('ctb', 'cph'), comment = "Files at src/third_party/protobuf-lite: google/protobuf/stubs/mathlimits.h (BSD-3 License)"),
    person('Susumu Yata', role = c('ctb', 'cph'), comment = "Files at src/third_party/darts_clone (BSD-3 License"),
    person('Daisuke Okanohara', role = c('ctb', 'cph'), comment = "File src/third_party/esaxx/esa.hxx (MIT License)"),
    person('Yuta Mori', role = c('ctb', 'cph'), comment = "File src/third_party/esaxx/sais.hxx (MIT License)"),
    person('Benjamin Heinzerling', role = c('ctb', 'cph'), comment = "Files data/models/nl.wiki.bpe.vs1000.d25.w2v.txt and data/models/nl.wiki.bpe.vs1000.model (MIT License)"))
Maintainer: Jan Wijffels <jwijffels@bnosac.be>
Description: Unsupervised text tokenizer allowing to perform byte pair encoding and unigram modelling. 
    Wraps the 'sentencepiece' library <https://github.com/google/sentencepiece> which provides a language independent tokenizer to split text in words and smaller subword units. 
    The techniques are explained in the paper "SentencePiece: A simple and language independent subword tokenizer and detokenizer for Neural Text Processing" by Taku Kudo and John Richardson (2018) <doi:10.18653/v1/D18-2012>.
    Provides as well straightforward access to pretrained byte pair encoding models and subword embeddings trained on Wikipedia using 'word2vec', 
    as described in "BPEmb: Tokenization-free Pre-trained Subword Embeddings in 275 Languages" by Benjamin Heinzerling and Michael Strube (2018) <http://www.lrec-conf.org/proceedings/lrec2018/pdf/1049.pdf>.
URL: https://github.com/bnosac/sentencepiece
License: MPL-2.0
Encoding: UTF-8
LazyData: true
RoxygenNote: 7.1.0
Depends: R (>= 2.10)
Imports: Rcpp (>= 0.11.5)
Suggests: tokenizers.bpe
LinkingTo: Rcpp
NeedsCompilation: yes
Packaged: 2020-05-29 19:27:35 UTC; Jan
Author: Jan Wijffels [aut, cre, cph] (R wrapper),
  BNOSAC [cph] (R wrapper),
  Google Inc. [ctb, cph] (Files at src/sentencepiece/src (Apache License,
    Version 2.0),
  The Abseil Authors [ctb, cph] (Files at src/third_party/absl (Apache
    License, Version 2.0),
  Google Inc. [ctb, cph] (Files at src/third_party/protobuf-lite (BSD-3
    License)),
  Kenton Varda (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite: coded_stream.cc, extension_set.cc,
    generated_message_util.cc, generated_message_util.cc,
    message_lite.cc, repeated_field.cc, wire_format_lite.cc,
    zero_copy_stream.cc, zero_copy_stream_impl_lite.cc,
    google/protobuf/extension_set.h,
    google/protobuf/generated_message_util.h,
    google/protobuf/wire_format_lite.h,
    google/protobuf/wire_format_lite_inl.h,
    google/protobuf/message_lite.h, google/protobuf/repeated_field.h,
    google/protobuf/io/coded_stream.h,
    google/protobuf/io/zero_copy_stream_impl_lite.h,
    google/protobuf/io/zero_copy_stream.h,
    google/protobuf/stubs/common.h, google/protobuf/stubs/hash.h,
    google/protobuf/stubs/once.h, google/protobuf/stubs/once.h.org
    (BSD-3 License)),
  Sanjay Ghemawat (Google Inc.) [ctb, cph] (Design of files at
    src/third_party/protobuf-lite: coded_stream.cc, extension_set.cc,
    generated_message_util.cc, generated_message_util.cc,
    message_lite.cc, repeated_field.cc, wire_format_lite.cc,
    zero_copy_stream.cc, zero_copy_stream_impl_lite.cc,
    google/protobuf/extension_set.h,
    google/protobuf/generated_message_util.h,
    google/protobuf/wire_format_lite.h,
    google/protobuf/wire_format_lite_inl.h,
    google/protobuf/message_lite.h, google/protobuf/repeated_field.h,
    google/protobuf/io/coded_stream.h,
    google/protobuf/io/zero_copy_stream_impl_lite.h,
    google/protobuf/io/zero_copy_stream.h (BSD-3 License)),
  Jeff Dean (Google Inc.) [ctb, cph] (Design of files at
    src/third_party/protobuf-lite: coded_stream.cc, extension_set.cc,
    generated_message_util.cc, generated_message_util.cc,
    message_lite.cc, repeated_field.cc, wire_format_lite.cc,
    zero_copy_stream.cc, zero_copy_stream_impl_lite.cc,
    google/protobuf/extension_set.h,
    google/protobuf/generated_message_util.h,
    google/protobuf/wire_format_lite.h,
    google/protobuf/wire_format_lite_inl.h,
    google/protobuf/message_lite.h, google/protobuf/repeated_field.h,
    google/protobuf/io/coded_stream.h,
    google/protobuf/io/zero_copy_stream_impl_lite.h,
    google/protobuf/io/zero_copy_stream.h (BSD-3 License)),
  Laszlo Csomor (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite: io_win32.cc,
    google/protobuf/stubs/io_win32.h (BSD-3 License)),
  Wink Saville (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite: message_lite.cc,
    google/protobuf/wire_format_lite.h,
    google/protobuf/wire_format_lite_inl.h,
    google/protobuf/message_lite.h (BSD-3 License)),
  Jim Meehan (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite: structurally_valid.cc (BSD-3
    License)),
  Chris Atenasio (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite: google/protobuf/wire_format_lite.h
    (BSD-3 License)),
  Jason Hsueh (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite:
    google/protobuf/io/coded_stream_inl.h (BSD-3 License)),
  Anton Carver (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite: google/protobuf/stubs/map_util.h
    (BSD-3 License)),
  Maxim Lifantsev (Google Inc.) [ctb, cph] (Files at
    src/third_party/protobuf-lite: google/protobuf/stubs/mathlimits.h
    (BSD-3 License)),
  Susumu Yata [ctb, cph] (Files at src/third_party/darts_clone (BSD-3
    License),
  Daisuke Okanohara [ctb, cph] (File src/third_party/esaxx/esa.hxx (MIT
    License)),
  Yuta Mori [ctb, cph] (File src/third_party/esaxx/sais.hxx (MIT
    License)),
  Benjamin Heinzerling [ctb, cph] (Files
    data/models/nl.wiki.bpe.vs1000.d25.w2v.txt and
    data/models/nl.wiki.bpe.vs1000.model (MIT License))
Repository: CRAN
Date/Publication: 2020-06-04 10:10:03 UTC

## sentencepiece 0.1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Package: sentencepiece
 Type: Package
 Title: Text Tokenization using Byte Pair Encoding and Unigram Modelling
-Version: 0.1.1
+Version: 0.1.2
 Authors@R: c(
     person('Jan', 'Wijffels', role = c('aut', 'cre', 'cph'), email = 'jwijffels@bnosac.be', comment = "R wrapper"), 
     person('BNOSAC', role = 'cph', comment = "R wrapper"), 
@@ -38,7 +38,7 @@
 Suggests: tokenizers.bpe
 LinkingTo: Rcpp
 NeedsCompilation: yes
-Packaged: 2020-05-29 19:27:35 UTC; Jan
+Packaged: 2020-06-05 10:47:10 UTC; Jan
 Author: Jan Wijffels [aut, cre, cph] (R wrapper),
   BNOSAC [cph] (R wrapper),
   Google Inc. [ctb, cph] (Files at src/sentencepiece/src (Apache License,
@@ -122,4 +122,4 @@
     data/models/nl.wiki.bpe.vs1000.d25.w2v.txt and
     data/models/nl.wiki.bpe.vs1000.model (MIT License))
 Repository: CRAN
-Date/Publication: 2020-06-04 10:10:03 UTC
+Date/Publication: 2020-06-08 21:40:02 UTC

## sentencepiece 0.1.83

=== CMakeLists.txt ===
# Copyright 2018 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.!

cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
file(STRINGS "VERSION" SPM_VERSION)
message(STATUS "VERSION: ${SPM_VERSION}")
project(sentencepiece VERSION ${SPM_VERSION} LANGUAGES C CXX)

option(SPM_ENABLE_NFKC_COMPILE "Enables NFKC compile" OFF)
option(SPM_ENABLE_SHARED "Builds shared libaries in addition to static libraries." ON)
option(SPM_BUILD_TEST "Builds test binaries." OFF)
option(SPM_COVERAGE "Runs gcov to test coverage." OFF)
option(SPM_ENABLE_TENSORFLOW_SHARED "Makes a tensorflow compatible shared file." OFF)
option(SPM_ENABLE_TCMALLOC "Enable TCMalloc if available." ON)
option(SPM_TCMALLOC_STATIC "Link static library of TCMALLOC." OFF)
option(SPM_NO_THREADLOCAL "Disable thread_local operator" OFF)
option(SPM_USE_BUILTIN_PROTOBUF "Use built-in protobuf" ON)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(libdir "\${exec_prefix}/lib")
set(includedir "\${prefix}/include")
set(GNUCXX_STD_SUPPORT_VERSION "4.3")

if (SPM_USE_BUILTIN_PROTOBUF)
  set(libprotobuf_lite "")
else()
  set(libprotobuf_lite "-lprotobuf-lite")
endif()

if (MSVC)
  string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_DEBUG          ${CMAKE_CXX_FLAGS_DEBUG})
  string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_MINSIZEREL     ${CMAKE_CXX_FLAGS_MINSIZEREL})
  string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELEASE        ${CMAKE_CXX_FLAGS_RELEASE})
  string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_RELWITHDEBINFO ${CMAKE_CXX_FLAGS_RELWITHDEBINFO})
  add_definitions("/wd4267 /wd4244 /wd4305 /Zc:strictStrings /utf-8")
endif()

if (APPLE)
  set(CMAKE_MACOSX_RPATH ON)
  set(CMAKE_SKIP_BUILD_RPATH FALSE)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
  list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
  if ("${isSystemDir}" STREQUAL "-1")
    set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  endif()
endif()

if (NOT DEFINED CMAKE_INSTALL_BINDIR)
  set(CMAKE_INSTALL_BINDIR bin)
endif()

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(CMAKE_INSTALL_LIBDIR lib)
endif()

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set(CMAKE_INSTALL_LIBDIR lib)
endif()

if (NOT DEFINED CMAKE_INSTALL_INCDIR)
  set(CMAKE_INSTALL_INCDIR include)
endif()

configure_file("${PROJECT_SOURCE_DIR}/config.h.in" "config.h")
configure_file("${PROJECT_SOURCE_DIR}/sentencepiece.pc.in" "sentencepiece.pc" @ONLY)

if (NOT MSVC)
  install(FILES "${CMAKE_BINARY_DIR}/sentencepiece.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif()

include_directories(${CMAKE_SOURCE_DIR} ${PROJECT_BINARY_DIR})

if (SPM_BUILD_TEST)
  enable_testing()
endif()

add_subdirectory(src)
add_subdirectory(third_party)

set(CPACK_SOURCE_GENERATOR "TXZ")
set(CPACK_GENERATOR "7Z")
set(CPACK_PACKAGE_VERSION "${SPM_VERSION}")
set(CPACK_STRIP_FILES TRUE)
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_README "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_PACKAGE_CONTACT "taku@google.com")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Taku Kudo")
set(CPACK_SOURCE_IGNORE_FILES "/build/;/.git/;/dist/;/sdist/;~$;${CPACK_SOURCE_IGNORE_FILES}")
include(CPack)

=== debian/changelog ===
sentencepiece (0.1.83-1) unstable; urgency=medium

  * Initial release

 -- Kentaro Hayashi <hayashi@clear-code.com>  Fri, 23 Aug 2019 18:27:54 +0900

=== debian/control ===
Source: sentencepiece
Priority: optional
Maintainer: Kentaro Hayashi <hayashi@clear-code.com>
Build-Depends:
 debhelper (>= 9),
 cmake,
 pkg-config,
 libgoogle-perftools-dev
Standards-Version: 3.9.8
Section: libs
Homepage: https://github.com/google/sentencepiece

Package: libsentencepiece-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libsentencepiece (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Development package for SentencePiece
 The SentencePiece is an unsupervised text tokenizer for Neural Network-based
 text generation.
 .
 This package contains header files to develop a software using SentencePiece.

Package: libsentencepiece
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library package for SentencePiece
 The SentencePiece is an unsupervised text tokenizer for Neural Network-based
 text generation.
 .
 This package contains runtime libraries for SentencePiece.

Package: libsentencepiece-tools
Architecture: any
Depends: libsentencepiece (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Tool collection package for SentencePiece
 The SentencePiece is an unsupervised text tokenizer for Neural Network-based
 text generation.
 .
 This package contains tools for manipulate models for SentencePiece.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

%:
	dh $@ --buildsystem=cmake

# Set -DCMAKE_INSTALL_LIBDIR explicitly because install DESTINATION (src/cmake_install.cmake)
# is not correctly set on Ubuntu 18.04.
override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%sentencepiece-$1-Source.tar.xz%" \
   https://github.com/google/sentencepiece/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## sentencepiece 0.1.84

=== CMakeLists.txt ===
--- 
+++ 
@@ -70,10 +70,6 @@
   set(CMAKE_INSTALL_LIBDIR lib)
 endif()
 
-if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
-  set(CMAKE_INSTALL_LIBDIR lib)
-endif()
-
 if (NOT DEFINED CMAKE_INSTALL_INCDIR)
   set(CMAKE_INSTALL_INCDIR include)
 endif()

=== src/CMakeLists.txt ===
# Copyright 2018 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.!

if (SPM_USE_BUILTIN_PROTOBUF)
  set(SPM_PROTO_HDRS builtin_pb/sentencepiece.pb.h)
  set(SPM_PROTO_SRCS builtin_pb/sentencepiece.pb.cc)
  set(SPM_MODEL_PROTO_HDRS builtin_pb/sentencepiece_model.pb.h)
  set(SPM_MODEL_PROTO_SRCS builtin_pb/sentencepiece_model.pb.cc)
  set(PROTOBUF_LITE_LIBRARY "")
  set(PROTOBUF_LITE_SRCS
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arena.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arenastring.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/bytestream.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/coded_stream.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/common.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/extension_set.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_table_driven_lite.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_util.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/implicit_weak_message.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/int128.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/io_win32.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/message_lite.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/repeated_field.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/status.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/statusor.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/stringpiece.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/stringprintf.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/structurally_valid.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/strutil.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/time.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/wire_format_lite.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream.cc
    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream_impl_lite.cc)
  if (MSVC)
    add_definitions("/DHAVE_PTHREAD /wd4018 /wd4514")
  else()
    add_definitions("-pthread -DHAVE_PTHREAD=1 -Wno-sign-compare")
  endif()
  include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite)
  include_directories(builtin_pb)
else()
  find_package(Protobuf REQUIRED)
  include_directories(${Protobuf_INCLUDE_DIRS})
  protobuf_generate_cpp(SPM_PROTO_SRCS SPM_PROTO_HDRS sentencepiece.proto)
  protobuf_generate_cpp(SPM_MODEL_PROTO_SRCS SPM_MODEL_PROTO_HDRS sentencepiece_model.proto)
  set(PROTOBUF_LITE_SRCS "")
  include_directories(${PROTOBUF_INCLUDE_DIR})
endif()

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(SPM_SRCS
  ${PROTOBUF_LITE_SRCS}
  ${SPM_PROTO_HDRS}
  ${SPM_PROTO_SRCS}
  ${SPM_MODEL_PROTO_HDRS}
  ${SPM_MODEL_PROTO_SRCS}
  bpe_model.h
  common.h
  normalizer.h
  util.h
  freelist.h
  filesystem.h
  flags.h
  sentencepiece_processor.h
  word_model.h
  model_factory.h
  char_model.h
  model_interface.h
  testharness.h
  unigram_model.h
  bpe_model.cc
  char_model.cc
  error.cc
  filesystem.cc
  flags.cc
  model_factory.cc
  model_interface.cc
  normalizer.cc
  sentencepiece_processor.cc
  unigram_model.cc
  util.cc
  word_model.cc
  ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/absl/strings/string_view.cc)

set(SPM_TRAIN_SRCS
  ${SPM_PROTO_HDRS}
  ${SPM_MODEL_PROTO_HDRS}
  builder.h
  normalization_rule.h
  unicode_script.h
  unicode_script_map.h
  trainer_factory.h
  trainer_interface.h
  unigram_model_trainer.h
  word_model_trainer.h
  char_model_trainer.h
  bpe_model_trainer.h
  sentencepiece_trainer.h
  builder.cc
  unicode_script.cc
  trainer_factory.cc
  trainer_interface.cc
  unigram_model_trainer.cc
  word_model_trainer.cc
  char_model_trainer.cc
  bpe_model_trainer.cc
  sentencepiece_trainer.cc)

set(SPM_TEST_SRCS
  ${SPM_PROTO_HDRS}
  ${SPM_MODEL_PROTO_HDRS}
  testharness.h
  bpe_model_test.cc
  bpe_model_trainer_test.cc
  builder_test.cc
  char_model_test.cc
  char_model_trainer_test.cc
  filesystem_test.cc
  flags_test.cc
  model_factory_test.cc
  model_interface_test.cc
  normalizer_test.cc
  sentencepiece_processor_test.cc
  sentencepiece_trainer_test.cc
  test_main.cc
  testharness.cc
  trainer_factory_test.cc
  trainer_interface_test.cc
  unicode_script_test.cc
  unigram_model_test.cc
  unigram_model_trainer_test.cc
  util_test.cc
  word_model_test.cc
  word_model_trainer_test.cc)

find_package(Threads REQUIRED)

set(SPM_LIBS ${PROTOBUF_LITE_LIBRARY} Threads::Threads)

if (SPM_ENABLE_NFKC_COMPILE)
  find_package(ICU 4.4 COMPONENTS i18n data uc REQUIRED)
  include_directories(${ICU_INCLUDE_DIRS})
  add_definitions(-DENABLE_NFKC_COMPILE)
  list(APPEND SPM_LIBS ICU::i18n ICU::data ICU::uc)
endif()

if (SPM_ENABLE_TCMALLOC)
  if (SPM_TCMALLOC_STATIC)
    find_library(TCMALLOC_LIB NAMES libtcmalloc_minimal.a)
  else()
    find_library(TCMALLOC_LIB NAMES tcmalloc_minimal)
  endif()
  if (TCMALLOC_LIB)
    message(STATUS "Found TCMalloc: ${TCMALLOC_LIB}")
    list(APPEND SPM_LIBS ${TCMALLOC_LIB})
    add_definitions(-fno-builtin-malloc -fno-builtin-calloc -fno-builtin-realloc -fno-builtin-free)
  else()
    message(STATUS "Not Found TCMalloc: ${TCMALLOC_LIB}")
  endif()
endif()

if (SPM_ENABLE_SHARED)
  add_library(sentencepiece SHARED ${SPM_SRCS})
  add_library(sentencepiece_train SHARED ${SPM_TRAIN_SRCS})
endif()

add_library(sentencepiece-static STATIC ${SPM_SRCS})
add_library(sentencepiece_train-static STATIC ${SPM_TRAIN_SRCS})

target_link_libraries(sentencepiece-static INTERFACE ${SPM_LIBS})
target_link_libraries(sentencepiece_train-static INTERFACE sentencepiece-static ${SPM_LIBS})

if (SPM_ENABLE_SHARED)
  target_link_libraries(sentencepiece ${SPM_LIBS})
  target_link_libraries(sentencepiece_train ${SPM_LIBS} sentencepiece)
  set(SPM_INSTALLTARGETS sentencepiece sentencepiece_train sentencepiece-static sentencepiece_train-static)
  set_target_properties(sentencepiece sentencepiece_train PROPERTIES SOVERSION 0 VERSION 0.0.0)
  set_target_properties(sentencepiece PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS YES)
  set_target_properties(sentencepiece_train PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS YES)
  if (MSVC)
    set_target_properties(sentencepiece PROPERTIES IMPORT_SUFFIX "_import.lib")
    set_target_properties(sentencepiece_train PROPERTIES IMPORT_SUFFIX "_import.lib")
  elseif (MINGW)
    set_target_properties(sentencepiece PROPERTIES IMPORT_SUFFIX ".dll.a")
    set_target_properties(sentencepiece_train PROPERTIES IMPORT_SUFFIX ".dll.a")
  endif()
else()
  add_library(sentencepiece ALIAS sentencepiece-static)
  add_library(sentencepiece_train ALIAS sentencepiece_train-static)
  set(SPM_INSTALLTARGETS sentencepiece-static sentencepiece_train-static)
endif()

set_target_properties(sentencepiece-static PROPERTIES OUTPUT_NAME "sentencepiece")
set_target_properties(sentencepiece_train-static PROPERTIES OUTPUT_NAME "sentencepiece_train")

if (NOT MSVC)
  if (SPM_COVERAGE)
    set(CMAKE_CXX_FLAGS "-O0 -Wall -fPIC -coverage ${CMAKE_CXX_FLAGS}")
  else()
    set(CMAKE_CXX_FLAGS "-O3 -Wall -fPIC ${CMAKE_CXX_FLAGS}")
  endif()
  if (SPM_ENABLE_TENSORFLOW_SHARED)
    add_definitions(-D_GLIBCXX_USE_CXX11_ABI=0)
  endif()
  if (SPM_NO_THREADLOCAL)
    add_definitions(-DSPM_NO_THREADLOCAL=1)
    add_definitions(-DGOOGLE_PROTOBUF_NO_THREADLOCAL=1)
  endif()
  set_source_files_properties(
    sentencepiece.pb.cc sentencepiece_model.pb.cc
    PROPERTIES COMPILE_FLAGS "-Wno-misleading-indentation")
  set_source_files_properties(${SPM_TEST_SRCS}
    PROPERTIES COMPILE_FLAGS "-Wno-sign-compare")
  if (SPM_ENABLE_SHARED)
    set_property(TARGET sentencepiece APPEND_STRING PROPERTY COMPILE_FLAGS " -DPIC")
    set_property(TARGET sentencepiece_train APPEND_STRING PROPERTY COMPILE_FLAGS " -DPIC")
  endif()
endif()

add_executable(spm_encode spm_encode_main.cc)
add_executable(spm_decode spm_decode_main.cc)
add_executable(spm_normalize spm_normalize_main.cc)
add_executable(spm_train spm_train_main.cc)
add_executable(spm_export_vocab spm_export_vocab_main.cc)

target_link_libraries(spm_encode sentencepiece)
target_link_libraries(spm_decode sentencepiece)
target_link_libraries(spm_normalize sentencepiece sentencepiece_train)
target_link_libraries(spm_train sentencepiece sentencepiece_train)
target_link_libraries(spm_export_vocab sentencepiece)

if (SPM_ENABLE_NFKC_COMPILE)
  add_executable(compile_charsmap compile_charsmap_main.cc)
  target_link_libraries(compile_charsmap sentencepiece sentencepiece_train)
endif()

list(APPEND SPM_INSTALLTARGETS
  spm_encode spm_decode spm_normalize spm_train spm_export_vocab)

install(TARGETS ${SPM_INSTALLTARGETS}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES sentencepiece_trainer.h sentencepiece_processor.h
  DESTINATION ${CMAKE_INSTALL_INCDIR})

file(TO_NATIVE_PATH "${PROJECT_SOURCE_DIR}/data" data_dir)

if (SPM_BUILD_TEST OR SPM_COVERAGE)
  enable_testing()
  add_executable(spm_test test_main.cc ${SPM_TEST_SRCS})

  if (SPM_COVERAGE)
    target_link_libraries(spm_test sentencepiece sentencepiece_train "-lgcov")
  else()
    target_link_libraries(spm_test sentencepiece sentencepiece_train)
  endif()

  set(MEMORYCHECK_COMMAND_OPTIONS "--leak-check=full --show-leak-kinds=definite,possible --error-exitcode=1")
  find_program(CTEST_MEMORYCHECK_COMMAND NAMES valgrind)
  include(Dart)

  add_test(NAME sentencepiece_test
    COMMAND $<TARGET_FILE:spm_test> --data_dir=${data_dir})
endif()

if (SPM_COVERAGE)
  add_custom_target(coverage
    COMMAND mkdir -p coverage
    COMMAND $<TARGET_FILE:spm_test> --data_dir=${data_dir}
    COMMAND lcov -c -d . -o coverage.info
    COMMAND lcov --remove coverage.info "include*" "/c++" "_test*" "testharness*" "third_party*" ".pb.*" -o coverage.info
    COMMAND mkdir -p lcov_html
    COMMAND genhtml -o lcov_html coverage.info)
  add_dependencies(coverage spm_test)
endif()

=== debian/changelog ===
sentencepiece (0.1.84-1build1) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:25:45 +0100

sentencepiece (0.1.84-1) unstable; urgency=medium

  * New upstream version 0.1.84 (Closes: #939860)

  [ TSUCHIYA Masatoshi ]
  * Initial packaging tasks.
  * Remove pipeline configurations for BitBucket.

  [ Kentaro Hayashi ]
  * debian/gbp.conf
    - Add basic configuration about debian-branch
  * debian/watch
    - Add missing watch file to detect a new release
  * debian/control
    - Update deprecated Priority: to optional
    - Add Vcs-* fields
    - Fix W: sentencepiece: description-synopsis-starts-with-article
    - Bump standard version to 4.4.1
    - Update Vcs-* under science-team
    - Bump up compatibility level
    - Drop python2 support
  * debian/copyright
    - Use https://
    - Update copyright about third party modules
  * debian/rules
    - Enable hardening
  * debian/salsa-ci.yml
    - Add Salsa CI configuration

 -- Kentaro Hayashi <hayashi@clear-code.com>  Thu, 17 Oct 2019 13:33:34 +0900

=== debian/control ===
Source: sentencepiece
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
  TSUCHIYA Masatoshi <tsuchiya@namazu.org>,
  Kentaro Hayashi <hayashi@clear-code.com>
Build-Depends:
 debhelper-compat (= 12),
 protobuf-compiler,
 libprotobuf-dev,
 dh-python,
 python3-all-dev,
 quilt,
 cmake,
 python3-setuptools
Standards-Version: 4.4.1
Homepage: https://github.com/google/sentencepiece
Vcs-Browser: https://salsa.debian.org/science-team/sentencepiece
Vcs-Git: https://salsa.debian.org/science-team/sentencepiece.git
Rules-Requires-Root: no

Package: sentencepiece
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Unsupervised text tokenizer and detokenizer
 SentencePiece is an unsupervised text tokenizer/detokenizer mainly
 designed for Neural Network-based text generation systems where the
 vocabulary size is predetermined prior to the neural model training.

Package: libsentencepiece0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library files of SentencePiece
 SentencePiece is an unsupervised text tokenizer/detokenizer mainly
 designed for Neural Network-based text generation systems where the
 vocabulary size is predetermined prior to the neural model training.

Package: libsentencepiece-dev
Section: libdevel
Architecture: any
Depends: libsentencepiece0 (= ${binary:Version}), ${misc:Depends}
Description: Header files of SentencePiece
 SentencePiece is an unsupervised text tokenizer/detokenizer mainly
 designed for Neural Network-based text generation systems where the
 vocabulary size is predetermined prior to the neural model training.

Package: python3-sentencepiece
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Description: SentencePiece binding for Python3
 SentencePiece is an unsupervised text tokenizer/detokenizer mainly
 designed for Neural Network-based text generation systems where the
 vocabulary size is predetermined prior to the neural model training.
 .
 python3-sentencepiece is its binding for Python3.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake
	dh_auto_configure --sourcedirectory=python --buildsystem=pybuild

override_dh_auto_build:
	dh_auto_build --buildsystem=cmake
	dh_auto_build --sourcedirectory=python --buildsystem=pybuild

override_dh_auto_install: basedir=$(shell pwd)/debian
override_dh_auto_install:
	dh_auto_install --buildsystem=cmake
	dh_auto_install --sourcedirectory=python --buildsystem=pybuild

override_dh_auto_clean:
	dh_auto_clean --buildsystem=cmake
	-rm -rf .pybuild
	-rm -rf .python/sentencepiece.egg-info

# Do no tests.
override_dh_auto_test:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%sentencepiece-$1-Source.tar.xz%" \
   https://github.com/google/sentencepiece/tags \
   (?:.*?/)?v(\d[\d.]*)\.tar\.gz debian uupdate

## sentencepiece 0.1.92

=== CMakeLists.txt ===
--- 
+++ 
@@ -81,7 +81,7 @@
   install(FILES "${CMAKE_BINARY_DIR}/sentencepiece.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 endif()
 
-include_directories(${CMAKE_SOURCE_DIR} ${PROJECT_BINARY_DIR})
+include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${PROJECT_BINARY_DIR})
 
 if (SPM_BUILD_TEST)
   enable_testing()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,17 +20,18 @@
   set(PROTOBUF_LITE_LIBRARY "")
   set(PROTOBUF_LITE_SRCS
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arena.cc
-    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arenastring.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/bytestream.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/coded_stream.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/common.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/extension_set.cc
+    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_enum_util.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_table_driven_lite.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_util.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/implicit_weak_message.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/int128.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/io_win32.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/message_lite.cc
+    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/parse_context.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/repeated_field.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/status.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/statusor.cc
@@ -41,6 +42,7 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/time.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/wire_format_lite.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream.cc
+    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream_impl.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream_impl_lite.cc)
   if (MSVC)
     add_definitions("/DHAVE_PTHREAD /wd4018 /wd4514")
@@ -59,6 +61,12 @@
 endif()
 
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
+
+if (MSVC)
+  add_definitions("/D_USE_INTERNAL_STRING_VIEW")
+else()
+  add_definitions("-D_USE_INTERNAL_STRING_VIEW")
+endif()
 
 set(SPM_SRCS
   ${PROTOBUF_LITE_SRCS}
@@ -72,7 +80,7 @@
   util.h
   freelist.h
   filesystem.h
-  flags.h
+  init.h
   sentencepiece_processor.h
   word_model.h
   model_factory.h
@@ -84,7 +92,7 @@
   char_model.cc
   error.cc
   filesystem.cc
-  flags.cc
+  init.cc
   model_factory.cc
   model_interface.cc
   normalizer.cc
@@ -92,7 +100,8 @@
   unigram_model.cc
   util.cc
   word_model.cc
-  ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/absl/strings/string_view.cc)
+  ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/absl/strings/string_view.cc
+  ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/absl/flags/flag.cc)
 
 set(SPM_TRAIN_SRCS
   ${SPM_PROTO_HDRS}
@@ -108,6 +117,7 @@
   char_model_trainer.h
   bpe_model_trainer.h
   sentencepiece_trainer.h
+  pretokenizer_for_training.h
   builder.cc
   unicode_script.cc
   trainer_factory.cc
@@ -116,7 +126,8 @@
   word_model_trainer.cc
   char_model_trainer.cc
   bpe_model_trainer.cc
-  sentencepiece_trainer.cc)
+  sentencepiece_trainer.cc
+  pretokenizer_for_training.cc)
 
 set(SPM_TEST_SRCS
   ${SPM_PROTO_HDRS}
@@ -128,7 +139,7 @@
   char_model_test.cc
   char_model_trainer_test.cc
   filesystem_test.cc
-  flags_test.cc
+  init_test.cc
   model_factory_test.cc
   model_interface_test.cc
   normalizer_test.cc
@@ -143,7 +154,8 @@
   unigram_model_trainer_test.cc
   util_test.cc
   word_model_test.cc
-  word_model_trainer_test.cc)
+  word_model_trainer_test.cc
+  pretokenizer_for_training_test.cc)
 
 find_package(Threads REQUIRED)
 
@@ -273,13 +285,13 @@
   include(Dart)
 
   add_test(NAME sentencepiece_test
-    COMMAND $<TARGET_FILE:spm_test> --data_dir=${data_dir})
+    COMMAND $<TARGET_FILE:spm_test> --test_srcdir=${data_dir})
 endif()
 
 if (SPM_COVERAGE)
   add_custom_target(coverage
     COMMAND mkdir -p coverage
-    COMMAND $<TARGET_FILE:spm_test> --data_dir=${data_dir}
+    COMMAND $<TARGET_FILE:spm_test> --test_srcdir=${data_dir}
     COMMAND lcov -c -d . -o coverage.info
     COMMAND lcov --remove coverage.info "include*" "/c++" "_test*" "testharness*" "third_party*" ".pb.*" -o coverage.info
     COMMAND mkdir -p lcov_html

=== debian/changelog ===
sentencepiece (0.1.92-1) unstable; urgency=medium

  * New upstream version 0.1.92

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 19 Jun 2020 19:38:49 +0900

sentencepiece (0.1.91-1) unstable; urgency=medium

  * New upstream version 0.1.91

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 22 May 2020 15:17:42 +0900

sentencepiece (0.1.90-3) unstable; urgency=medium

  * debian/patches/0004-Fix-FTBFS-on-armel-and-mipsel.patch
    - Refresh patch to fix FTBFS.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 17 May 2020 09:02:23 +0900

sentencepiece (0.1.90-2) unstable; urgency=medium

  * debian/patches/0004-Fix-FTBFS-on-armel-and-mipsel.patch
    - Add patch to fix FTBFS on mipsel and armel

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 16 May 2020 16:16:45 +0900

sentencepiece (0.1.90-1) unstable; urgency=medium

  * New upstream version 0.1.90
  * debian/control
    - Update Uploaders:
    - Bump standard-version to 4.5.0
    - Bump compat version to 13.
  * debian/source/lintian-overrides
    - Fix false positive source-is-missing
  * debian/patches/0003-Disable-static-library-explicitly.patch
    - Disable to build static library

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 13 May 2020 19:09:34 +0900

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders:
   TSUCHIYA Masatoshi <tsuchiya@namazu.org>,
-  Kentaro Hayashi <hayashi@clear-code.com>
+  Kentaro Hayashi <kenhys@xdump.org>
 Build-Depends:
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  protobuf-compiler,
  libprotobuf-dev,
  dh-python,
@@ -14,7 +14,7 @@
  quilt,
  cmake,
  python3-setuptools
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Homepage: https://github.com/google/sentencepiece
 Vcs-Browser: https://salsa.debian.org/science-team/sentencepiece
 Vcs-Git: https://salsa.debian.org/science-team/sentencepiece.git

## sentencepiece 0.1.93

=== debian/changelog ===
sentencepiece (0.1.93-1) unstable; urgency=medium

  * New upstream version 0.1.93
  * debian/source/lintian-overrides
    - Remove needless override.

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 15 Oct 2020 21:32:05 +0900

sentencepiece (0.1.92-3) unstable; urgency=medium

  * debian/patches/fix-ftbfs-ports.patch
    - Fix FTBFS on powerpc

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 03 Oct 2020 20:48:27 +0900

sentencepiece (0.1.92-2) unstable; urgency=medium

  * debian/patches/0002-Change-in-order-to-build-Python-modules-in-place.patch
    - Fix FTBFS on hurd-i386
  * debian/patches/0004-Fix-FTBFS-on-armel-and-mipsel.patch
    - Fix missing dependency to atomic library (powerpc,m68k,sh4)

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 26 Sep 2020 20:27:17 +0900

## sentencepiece 0.1.94

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,10 +30,18 @@
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-set(prefix ${CMAKE_INSTALL_PREFIX})
-set(exec_prefix "\${prefix}")
-set(libdir "\${exec_prefix}/lib")
-set(includedir "\${prefix}/include")
+if (UNIX)
+  include(GNUInstallDirs)
+  set(prefix ${CMAKE_INSTALL_PREFIX})
+  set(exec_prefix "\${prefix}")
+  set(libdir "\${exec_prefix}/${CMAKE_INSTALL_LIBDIR}")
+  set(includedir "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
+else()
+  set(prefix ${CMAKE_INSTALL_PREFIX})
+  set(exec_prefix "\${prefix}")
+  set(libdir "\${exec_prefix}/lib")
+  set(includedir "\${prefix}/include")
+endif()
 set(GNUCXX_STD_SUPPORT_VERSION "4.3")
 
 if (SPM_USE_BUILTIN_PROTOBUF)
@@ -78,7 +86,7 @@
 configure_file("${PROJECT_SOURCE_DIR}/sentencepiece.pc.in" "sentencepiece.pc" @ONLY)
 
 if (NOT MSVC)
-  install(FILES "${CMAKE_BINARY_DIR}/sentencepiece.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/sentencepiece.pc" DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 endif()
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${PROJECT_BINARY_DIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,18 +20,17 @@
   set(PROTOBUF_LITE_LIBRARY "")
   set(PROTOBUF_LITE_SRCS
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arena.cc
+    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/arenastring.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/bytestream.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/coded_stream.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/common.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/extension_set.cc
-    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_enum_util.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_table_driven_lite.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/generated_message_util.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/implicit_weak_message.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/int128.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/io_win32.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/message_lite.cc
-    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/parse_context.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/repeated_field.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/status.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/statusor.cc
@@ -42,7 +41,6 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/time.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/wire_format_lite.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream.cc
-    ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream_impl.cc
     ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/protobuf-lite/zero_copy_stream_impl_lite.cc)
   if (MSVC)
     add_definitions("/DHAVE_PTHREAD /wd4018 /wd4514")
@@ -197,6 +195,13 @@
 if (SPM_ENABLE_SHARED)
   target_link_libraries(sentencepiece ${SPM_LIBS})
   target_link_libraries(sentencepiece_train ${SPM_LIBS} sentencepiece)
+  if ((${CMAKE_SYSTEM_PROCESSOR} STREQUAL "armv7l") OR
+      (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "mips") OR
+      (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "m68k") OR
+      (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "ppc") OR
+      (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "sh4"))
+    list(APPEND SPM_LIBS "atomic")
+  endif()
   set(SPM_INSTALLTARGETS sentencepiece sentencepiece_train sentencepiece-static sentencepiece_train-static)
   set_target_properties(sentencepiece sentencepiece_train PROPERTIES SOVERSION 0 VERSION 0.0.0)
   set_target_properties(sentencepiece PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS YES)

=== debian/changelog ===
sentencepiece (0.1.94-2) unstable; urgency=medium

  * Fix FTBFS on armel/mipsel (Closes: #977235)

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 16 Dec 2020 21:18:15 +0900

sentencepiece (0.1.94-1) unstable; urgency=medium

  * New upstream version 0.1.94
  * debian/patches/support-python-module-in-place.patch
    - Refresh path to build python module.
  * debian/patches/fix-ftbfs-ports.patch
    debian/patches/mutiarch-support.patch
    - Remove needless patch because these patch was merged
      to google/sentencepiece.

 -- Kentaro Hayashi <kenhys@xdump.org>  Wed, 28 Oct 2020 21:02:07 +0900
